from setuptools import setup, Extension
from Cython.Build import cythonize
import numpy

setup(
    packages=['pktree', 'pktree.tree'],
    package_data={'': ['*.pxd', '*.pyx']},
    ext_modules=cythonize(
        [Extension(
            "pktree.hello",
            sources=["pktree/hello.pyx"]
        ),
        Extension(
            "pktree.tree._criterion",
            sources=["pktree/tree/_criterion.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.tree._partitioner",
            sources=["pktree/tree/_partitioner.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.tree._splitter",
            sources=["pktree/tree/_splitter.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.tree._tree",
            sources=["pktree/tree/_tree.pyx"],
            include_dirs=[numpy.get_include()],
            language="c++"
        ),
        Extension(
            "pktree.tree._utils",
            sources=["pktree/tree/_utils.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.ensemble._gradient_boosting",
            sources=["pktree/ensemble/_gradient_boosting.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.ensemble._hist_gradient_boosting._binning",   
            sources=["pktree/ensemble/_hist_gradient_boosting/_binning.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.ensemble._hist_gradient_boosting._bitset",   
            sources=["pktree/ensemble/_hist_gradient_boosting/_bitset.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.ensemble._hist_gradient_boosting.common",
            sources=["pktree/ensemble/_hist_gradient_boosting/common.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.ensemble._hist_gradient_boosting._gradient_boosting",
            sources=["pktree/ensemble/_hist_gradient_boosting/_gradient_boosting.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.ensemble._hist_gradient_boosting.histogram",
            sources=["pktree/ensemble/_hist_gradient_boosting/histogram.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.ensemble._hist_gradient_boosting.splitting",
            sources=["pktree/ensemble/_hist_gradient_boosting/splitting.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        Extension(
            "pktree.ensemble._hist_gradient_boosting._predictor",
            sources=["pktree/ensemble/_hist_gradient_boosting/_predictor.pyx"],
            include_dirs=[numpy.get_include()]
        ),
        ]
    )
)